import * as React from 'react';
import {ModelTableActionButtonProps, ModelTableDeleteButton as Original} from "@rx-suite/ui";
import {UserModel} from "../../stores/UserStore";
import {CurrentUserStore} from "@rx-suite/stores";
import {Model} from "@rx-suite/data";

export const RolesModelTableDeleteButton: React.FunctionComponent<ModelTableActionButtonProps> = ({model, store}) => {
    const user = CurrentUserStore.selectedModel as UserModel;

    // user can have a null role_id
    // role doesn't appear to be a model?
    if (user.role && model.getId() === (user.role as Model).id) {
        return null;
    } else {
        return <Original store={store} model={model}/>
    }
}