# This file is auto-generated from the current state of the database. Instead
# of editing this file, please use the migrations feature of Active Record to
# incrementally modify your database, and then regenerate this schema definition.
#
# This file is the source Rails uses to define your schema when running `rails
# db:schema:load`. When creating a new database, `rails db:schema:load` tends to
# be faster and is potentially less error prone than running all of your
# migrations from scratch. Old migrations may fail to apply correctly if those
# migrations use external dependencies or application code.
#
# It's strongly recommended that you check this file into your version control system.

ActiveRecord::Schema.define(version: 2023_05_08_155525) do

  create_table "active_storage_attachments", force: :cascade do |t|
    t.string "name", null: false
    t.string "record_type", null: false
    t.bigint "record_id", null: false
    t.bigint "blob_id", null: false
    t.datetime "created_at", null: false
    t.index ["blob_id"], name: "index_active_storage_attachments_on_blob_id"
    t.index ["record_type", "record_id", "name", "blob_id"], name: "index_active_storage_attachments_uniqueness", unique: true
  end

  create_table "active_storage_blobs", force: :cascade do |t|
    t.string "key", null: false
    t.string "filename", null: false
    t.string "content_type"
    t.text "metadata"
    t.bigint "byte_size", null: false
    t.string "checksum", null: false
    t.datetime "created_at", null: false
    t.index ["key"], name: "index_active_storage_blobs_on_key", unique: true
  end

  create_table "calendar_configs", force: :cascade do |t|
    t.integer "start", default: 7
    t.integer "end", default: 19
    t.boolean "weekend", default: false
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
  end

  create_table "component_permissions", force: :cascade do |t|
    t.string "action_id"
    t.string "target_id"
    t.string "action_display_name"
    t.string "target_display_name"
    t.bigint "component_id", null: false
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.string "target_category"
    t.string "feature_module_id"
    t.string "feature_subfeature_id"
    t.index ["component_id"], name: "index_component_permissions_on_component_id"
  end

  create_table "components", force: :cascade do |t|
    t.string "type"
    t.string "ip_address"
    t.integer "port"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.string "module_id"
    t.string "module_name"
    t.string "description"
    t.string "version"
    t.boolean "reachable"
    t.bigint "email_id"
    t.boolean "is_api"
    t.boolean "is_updating"
    t.string "last_update_error"
    t.string "update_status"
    t.string "protocol", default: "http"
    t.string "token"
    t.boolean "has_token"
    t.boolean "has_update_available"
    t.string "highest_available_update"
    t.datetime "last_successful_ping_at"
    t.datetime "last_ping_at"
    t.text "last_ping_result"
    t.boolean "licenced"
    t.string "external_address"
    t.integer "external_port"
    t.boolean "delegate_requests_through_hub", default: false
    t.index ["email_id"], name: "index_components_on_email_id"
    t.index ["module_id"], name: "index_components_on_module_id", unique: true
    t.index ["port", "ip_address"], name: "index_components_on_port_and_ip_address", unique: true
  end

  create_table "configs", force: :cascade do |t|
    t.string "encryption_key"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
  end

  create_table "emails", force: :cascade do |t|
    t.string "address"
    t.string "password"
    t.string "server"
    t.integer "port"
    t.boolean "is_system_default"
    t.boolean "auth"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.string "auth_type"
  end

  create_table "licence_infos", force: :cascade do |t|
    t.string "licence_code"
    t.string "licence_token"
    t.datetime "last_check_attempt"
    t.datetime "last_successful_check"
    t.string "last_check_error"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.boolean "legacy"
  end

  create_table "login_tokens", force: :cascade do |t|
    t.string "value"
    t.bigint "user_id", null: false
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.string "routine"
    t.index ["user_id"], name: "index_login_tokens_on_user_id"
  end

  create_table "o_auths", force: :cascade do |t|
    t.integer "service"
    t.bigint "user_id", null: false
    t.string "access_token"
    t.string "refresh_token"
    t.datetime "expires_at"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.string "refresh_url"
    t.boolean "selected"
    t.boolean "last_refresh_success"
    t.string "last_refresh_message"
    t.string "raw_refresh_response"
    t.datetime "last_refresh_time"
    t.string "account_identifier"
    t.string "service_name"
    t.index ["user_id"], name: "index_o_auths_on_user_id"
  end

  create_table "role_permissions", force: :cascade do |t|
    t.boolean "permitted"
    t.bigint "component_permission_id", null: false
    t.bigint "role_id", null: false
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["component_permission_id"], name: "index_role_permissions_on_component_permission_id"
    t.index ["role_id"], name: "index_role_permissions_on_role_id"
  end

  create_table "roles", force: :cascade do |t|
    t.string "name"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
  end

  create_table "rx_module_logger_configs", force: :cascade do |t|
    t.string "location"
    t.string "level"
    t.integer "archive_count"
    t.integer "max_size"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
  end

  create_table "rx_module_model_audit_lines", force: :cascade do |t|
    t.bigint "rx_module_model_audit_id", null: false
    t.text "before"
    t.text "after"
    t.string "column"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["rx_module_model_audit_id"], name: "index_rx_module_model_audit_lines_on_rx_module_model_audit_id"
  end

  create_table "rx_module_model_audits", force: :cascade do |t|
    t.string "user_id"
    t.string "user_email"
    t.string "user_role"
    t.string "table"
    t.string "action"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.bigint "model_id"
  end

  create_table "rx_module_tokens", force: :cascade do |t|
    t.string "value"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.integer "owner"
  end

  create_table "rx_module_update_histories", force: :cascade do |t|
    t.string "user"
    t.string "from_version"
    t.string "to_version"
    t.boolean "was_error"
    t.string "error_msg"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.boolean "in_progress"
    t.index ["created_at"], name: "index_rx_module_update_histories_on_created_at"
  end

  create_table "rx_module_worker_broadcasts", force: :cascade do |t|
    t.string "model_global_id"
    t.string "action"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
  end

  create_table "shift_schedules", force: :cascade do |t|
    t.bigint "shift_id", null: false
    t.integer "shift_length"
    t.datetime "start_date"
    t.datetime "end_date"
    t.string "recurrence_rule"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.index ["shift_id"], name: "index_shift_schedules_on_shift_id"
  end

  create_table "shifts", force: :cascade do |t|
    t.string "name"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.string "color"
  end

  create_table "system_settings", force: :cascade do |t|
    t.string "time_format", default: "HH:mm:ss"
    t.string "date_format", default: "YYYY/MM/DD"
    t.string "date_time_separator", default: " - "
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.integer "lens_tray_orientation", default: 0
    t.string "customer_type"
  end

  create_table "users", force: :cascade do |t|
    t.string "email"
    t.string "name"
    t.string "password_digest"
    t.datetime "created_at", precision: 6, null: false
    t.datetime "updated_at", precision: 6, null: false
    t.bigint "role_id"
    t.string "password_reset_token"
    t.integer "table_size", default: 10
    t.index ["email"], name: "index_users_on_email"
    t.index ["role_id"], name: "index_users_on_role_id"
  end

  add_foreign_key "active_storage_attachments", "active_storage_blobs", column: "blob_id"
  add_foreign_key "component_permissions", "components", on_delete: :cascade
  add_foreign_key "components", "emails", on_delete: :nullify
  add_foreign_key "login_tokens", "users", on_delete: :cascade
  add_foreign_key "o_auths", "users", on_delete: :cascade
  add_foreign_key "role_permissions", "component_permissions", on_delete: :cascade
  add_foreign_key "role_permissions", "roles", on_delete: :cascade
  add_foreign_key "rx_module_model_audit_lines", "rx_module_model_audits"
  add_foreign_key "shift_schedules", "shifts", on_delete: :cascade
  add_foreign_key "users", "roles", on_delete: :cascade
end
